const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const units_of_measure = sequelize.define(
    'units_of_measure',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

code: {
        type: DataTypes.TEXT,
      
      

      },

name: {
        type: DataTypes.TEXT,
      
      

      },

uom_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"count",


"weight",


"volume",


"length",


"area",


"time"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  units_of_measure.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity










    db.units_of_measure.hasMany(db.materials, {
      as: 'materials_uom',
      foreignKey: {
          name: 'uomId',
      },
      constraints: false,
    });























//end loop






    db.units_of_measure.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.units_of_measure.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return units_of_measure;
};


